from Tkinter import *
import time
import math
import mutex
import sys

class RTC_GUI(Frame):
    def but_init(self):
       	button = Button(self, text = "Python/Tkinter")
        button.pack()

        
    def __init__(self, r=10, width=300, height=300, master=None):
        Frame.__init__(self, master)

        self.pack()
        self.but_init()

    def get_data(self):
        return self.pos_x, self.pos_y, self.pol_r, self.pol_th

    def on_pos_update(self, pos, pol):
        self.pos_x = pos[0] * self.scale_var.get()
        self.pos_y = pos[1] * self.scale_var.get()
        self.pol_r = pol[0] * self.scale_var.get()
        self.pol_th = pol[1]

        xt = '%4d' % (self.pos_x)
        yt = '%4d' % (self.pos_y)
        rt = '%5.2f' % (self.pol_r)
        if pol[1] > 360: tht = 'NaN'
        else: tht = '%5.2f' % self.pol_th

        self.xentry.set(xt)
        self.yentry.set(yt)
        self.rentry.set(rt)
        self.thentry.set(tht)

        text = 'x: %4d, y: %4d' % (pos[0], pos[1])
        self.can_xytext.draw_text(self.xytext_x, self.xytext_y, text)
        if pol[1] > 360:
            text = 'r: %5.2f, th: NaN' % (pol[0])
        else:
            text = 'r: %5.2f, th: %5.2f' % (pol[0], pol[1])
        self.can_poltext.draw_text(self.poltext_x, self.poltext_y, text)

        self.can_vline.draw_line(self.x0, self.y0,
                                 self.x0 + pos[0],
                                 self.y0 - pos[1])

        if self.on_update != None:
            self.on_update((self.pos_x, self.pos_y),
                           (self.pol_r, self.pol_th))

    def set_on_update(self, func):
        self.on_update = func

def test ():
    m = Test_GUI()

    while 1:
        m.update()
        print m.get_pos()


if  __name__ == '__main__': test()
